
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.5.4">
    
    
      
        <title>Temporal queries - Eclipse Hawk™</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.80dcb947.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
      

    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
<!-- FAVICON -->
<link rel="apple-touch-icon" sizes="180x180" href="../../assets/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="../../assets/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/favicon-16x16.png">
<link rel="mask-icon" href="../../assets/images/safari-pinned-tab.svg" color="#5bbad5">
<link rel="shortcut icon" href="../../assets/images/favicon.ico">
<meta name="msapplication-TileColor" content="#b91d47">
<meta name="msapplication-config" content="../../assets/images/browserconfig.xml">
<meta name="theme-color" content="#ffffff">

  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#data-model" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="../.." title="Eclipse Hawk™" class="md-header__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Eclipse Hawk™
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Temporal queries
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
      </div>
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Eclipse Hawk™" class="md-nav__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    Eclipse Hawk™
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Home
      </a>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" >
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Basic use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Basic use" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Basic use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/installation/" class="md-nav__link">
        Installation
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/core-concepts/" class="md-nav__link">
        Core concepts
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/examples-xmi/" class="md-nav__link">
        Examples (XMI)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/examples-modelio/" class="md-nav__link">
        Examples (Modelio)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/papyrus/" class="md-nav__link">
        Papyrus UML support
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Advanced use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Advanced use" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Advanced use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../graph-as-emf/" class="md-nav__link">
        Graph as EMF model
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../advanced-props/" class="md-nav__link">
        Advanced properties
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../meta-queries/" class="md-nav__link">
        Meta-level queries
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Temporal queries
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Temporal queries
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#data-model" class="md-nav__link">
    Data model
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#basic-history-traversal-primitives" class="md-nav__link">
    Basic history traversal primitives
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#temporal-assertions" class="md-nav__link">
    Temporal assertions
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-predicate-based" class="md-nav__link">
    Scoping views (predicate-based)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-context-based" class="md-nav__link">
    Scoping views (context-based)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-based-on-derived-attributes" class="md-nav__link">
    Scoping views (based on derived attributes)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#global-operations-on-the-model" class="md-nav__link">
    Global operations on the model
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#some-examples" class="md-nav__link">
    Some examples
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#timeline-queries" class="md-nav__link">
    Timeline queries
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#current-limitations" class="md-nav__link">
    Current limitations
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../oomph/" class="md-nav__link">
        Oomph and Hawk
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Server
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Server" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Server
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/architecture/" class="md-nav__link">
        Architecture
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api/" class="md-nav__link">
        Thrift API
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/api-security/" class="md-nav__link">
        Thrift API security
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/deployment/" class="md-nav__link">
        Deployment
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/cli/" class="md-nav__link">
        Console client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/eclipse/" class="md-nav__link">
        Eclipse client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/other-languages/" class="md-nav__link">
        Cross-language clients
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/file-config/" class="md-nav__link">
        File-based configuration
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../server/logging/" class="md-nav__link">
        Logging
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Developers
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Developers" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Developers
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/run-from-source/" class="md-nav__link">
        Run GUI from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/server-from-source/" class="md-nav__link">
        Run Server from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/plain-maven/" class="md-nav__link">
        Build with plain Maven
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/website/" class="md-nav__link">
        Work on the website
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Community
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Community" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Community
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://www.eclipse.org/forums/index.php/f/442/" class="md-nav__link">
        Forum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues/new" class="md-nav__link">
        File a bug
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues" class="md-nav__link">
        Open bugs
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://ci.eclipse.org/hawk/" class="md-nav__link">
        Builds
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../../additional-resources/" class="md-nav__link">
        Additional resources
      </a>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#data-model" class="md-nav__link">
    Data model
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#basic-history-traversal-primitives" class="md-nav__link">
    Basic history traversal primitives
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#temporal-assertions" class="md-nav__link">
    Temporal assertions
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-predicate-based" class="md-nav__link">
    Scoping views (predicate-based)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-context-based" class="md-nav__link">
    Scoping views (context-based)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#scoping-views-based-on-derived-attributes" class="md-nav__link">
    Scoping views (based on derived attributes)
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#global-operations-on-the-model" class="md-nav__link">
    Global operations on the model
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#some-examples" class="md-nav__link">
    Some examples
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#timeline-queries" class="md-nav__link">
    Timeline queries
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#current-limitations" class="md-nav__link">
    Current limitations
  </a>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  


  <h1>Temporal queries</h1>

<p>The latest versions of Hawk have the capability to index every version of all the models in the locations being monitored. To enable this capability, your Hawk index must meet certain conditions:</p>
<ul>
<li>You must be using a time-aware backend: Greycat, or the time-aware version of the SQLite backend.</li>
<li>You must be using the time-aware updater (TimeAwareModelUpdater) and not the standard one.</li>
<li>You must be using the time-aware indexer factory and not the standard one (TimeAwareHawkFactory).</li>
<li>You must query the index with a time-aware query language:<ul>
<li><code>org.eclipse.hawk.timeaware.queries.TimeAwareEOLQueryEngine</code></li>
<li><code>org.eclipse.hawk.timeaware.queries.TimelineEOLQueryEngine</code></li>
</ul>
</li>
</ul>
<p>If you meet these constraints, you can index SVN/Git repositories with models and Hawk will turn the full history of every model into an integrated temporal graph database, or index a workspace/local folder and have Hawk remember the history of every model from then onwards. You will be able to query this temporal graph through an extension of Hawk's EOL dialect.</p>
<p>This functionality was first discussed in our <a href="http://st.inf.tu-dresden.de/MRT18/">MRT 2018</a> paper, "Reflecting on the past and the present with temporal graph-based models".</p>
<h2 id="data-model">Data model<a class="headerlink" href="#data-model" title="Permanent link">&para;</a></h2>
<p>The usual type -&gt; model element graph in Hawk is extended to give both types and model elements their own histories. The histories are defined as follows:</p>
<ul>
<li>Types are immortal: they are created at the first endpoint in the graph and last to the "end of time" of the graph. There is a new version whenever an instance of the type is created or destroyed.</li>
<li>Model elements are created at a certain timepoint, and either survive or are destroyed at another timepoint. Model elements are assumed to have a persistent identity: either its natural/artificial identifier, or its location within the model. New versions are produced when an attribute or a reference changes.</li>
</ul>
<p>Timepoints are provided by the Hawk connectors, and they tend to be commit timestamps or file timestamps. In SVN, these are commit timestamps to millisecond precision.</p>
<h2 id="basic-history-traversal-primitives">Basic history traversal primitives<a class="headerlink" href="#basic-history-traversal-primitives" title="Permanent link">&para;</a></h2>
<p>The actual primitives are quite simple. In the time-aware dialect of Hawk, types and model elements expose the following additional attributes and operations:</p>
<ul>
<li><code>x.versions</code>: returns the sequence of all versions for <code>x</code>, from newest to oldest</li>
<li><code>x.getVersionsBetween(from, to)</code>: versions within a range of timepoints</li>
<li><code>x.getVersionsFrom(from)</code>: versions from a timepoint (included)</li>
<li><code>x.getVersionsUpTo(from)</code>: versions up to a timepoint (included) </li>
<li><code>x.earliest</code>, <code>x.latest</code>: earliest / latest version</li>
<li><code>x.next</code>, <code>x.prev</code>/<code>x.previous</code>: next / previous version</li>
<li><code>x.time</code>: version timepoint</li>
<li><code>x.isAlive</code> (since 2.3.0): return <code>true</code> if and only if the node is valid at its current timepoint</li>
</ul>
<p>Since 2.3.0, there are specific operations for fetching all the incoming/outgoing references of a node within a certain time range (which may have backend-specific optimisations):</p>
<ul>
<li><code>x.getOutgoingEdgesWithTypeBetween(type, fromInclusive, toInclusive)</code>: all unique outgoing <a href="../advanced-props/#references">references</a> from <code>x</code> that existed between two timepoints (both included)</li>
<li><code>x.getIncomingEdgesWithTypeBetween(type, fromInclusive, toInclusive)</code>: all unique incoming <a href="../advanced-props/#references">references</a> to <code>x</code> that existed between two timepoints (both included)</li>
</ul>
<h2 id="temporal-assertions">Temporal assertions<a class="headerlink" href="#temporal-assertions" title="Permanent link">&para;</a></h2>
<p>It is possible to evaluate assertions over the history of a type or model element:</p>
<ul>
<li><code>x.always(version | predicate over version)</code>: true if and only if ("iff") the predicate is true for every version of <code>x</code>.</li>
<li><code>x.never(version | predicate over version)</code>: true iff the predicate is false for every version of <code>x</code>.</li>
<li><code>x.eventually(version | predicate over version)</code>: true iff the predicate is true for some version of <code>x</code>.</li>
<li><code>x.eventuallyAtLeast(version | predicate over version, count)</code>: true iff the predicate is true in at least <code>count</code> versions of <code>x</code>.</li>
<li><code>x.eventuallyAtMost(version | predicate over version, count)</code>: true iff the predicate is true in at least one version and at most <code>count</code> versions of <code>x</code>.</li>
</ul>
<h2 id="scoping-views-predicate-based">Scoping views (predicate-based)<a class="headerlink" href="#scoping-views-predicate-based" title="Permanent link">&para;</a></h2>
<p>The versions in scope for the above assertions and primitives can be limited with:</p>
<ul>
<li><code>x.since(version | predicate over version)</code> will return the type/model element in the oldest timepoint since that of <code>x</code> for which the predicate holds, or <code>null</code> if it does not exist. The returned type/model element will only report versions from its timepoint onwards. This esentially imposes a left-closed version interval.</li>
<li><code>x.after(version | predicate over version)</code> will return the type/model element in the timepoint immediately after the oldest timepoint for which the predicate holds, or <code>null</code> if it does not exist. It is essentially a variant of <code>x.since</code> that implements a left-open interval.</li>
<li><code>x.until(version | predicate over version)</code> will return the the same type/model element, but it will only report versions up to and including the first one for which the predicate holds, or <code>null</code> if such a version does not exist. This implements a right-closed version interval.</li>
<li><code>x.before(version | predicate over version)</code> will return the same type/model element, but it will only report versions before (excluding) the first one for which the predicate holds, or <code>null</code> if such a version does not exist. This implements a right-open interval.</li>
<li><code>x.when(version | predicate over version)</code> will return the type/model element in the oldest timepoint since that of <code>x</code> for which the predicate holds, or <code>null</code> if it does not exist. The returned type/model element will only report versions from its timepoint onwards that match the predicate. This is a left-closed, filtered interval.</li>
</ul>
<h2 id="scoping-views-context-based">Scoping views (context-based)<a class="headerlink" href="#scoping-views-context-based" title="Permanent link">&para;</a></h2>
<p>You can also limit the available versions from an existing type / model element:</p>
<ul>
<li><code>x.sinceThen</code>: version of <code>x</code> that will only report the versions from <code>x</code> onwards (included).</li>
<li><code>x.afterThen</code>: next version of <code>x</code> that will only report the versions after <code>x</code> (excluded). <code>null</code> if a next version does not exist.</li>
<li><code>x.untilThen</code>: version of <code>x</code> that will only report the versions up to <code>x</code> (included).</li>
<li><code>x.beforeThen</code>: previous version of <code>x</code> that will only report the versions before <code>x</code> (excluded). <code>null</code> if a previous version does not exist.</li>
</ul>
<p>You can undo the scoping with <code>.unscoped</code>. This will give you the same model element or type, but with all the versions available once more.</p>
<h2 id="scoping-views-based-on-derived-attributes">Scoping views (based on derived attributes)<a class="headerlink" href="#scoping-views-based-on-derived-attributes" title="Permanent link">&para;</a></h2>
<p>Some of the events we may be interested in may be very rare. In long histories, it may be very expensive to find such rare events by iterating over all the versions of a model element. In these cases, it is possible to define a derived Boolean attribute (e.g. <code>HasManyChildren</code> for a <code>Tree</code>, with definiton <code>return self.children.size &gt; 100;</code>) on a type, and then use these additional operations:</p>
<ul>
<li><code>x.whenAnnotated('AttributeName')</code>: returns a view of the model element <code>x</code> that exposes all the versions when the derived attribute named <code>AttributeName</code> defined on the type of <code>x</code> was <code>true</code>. The view will be at the earliest timepoint when this happened.</li>
<li><code>x.sinceAnnotated('AttributeName')</code>: equivalent to <code>since</code>, but using the derived attribute <code>AttributeName</code>.</li>
<li><code>x.afterAnnotated('AttributeName')</code>: equivalent to <code>after</code>. See above.</li>
<li><code>x.untilAnnotated('AttributeName')</code>: equivalent to <code>until</code>. See above.</li>
<li><code>x.beforeAnnotated('AttributeName')</code>: equivalent to <code>before</code>. See above.</li>
</ul>
<p><em>IMPORTANT</em>: you will need to define these derived attributes <em>before</em> you index any model versions.</p>
<h2 id="global-operations-on-the-model">Global operations on the model<a class="headerlink" href="#global-operations-on-the-model" title="Permanent link">&para;</a></h2>
<p>The <code>Model</code> global reference is extended with new operations:</p>
<ul>
<li><code>Model.allInstancesNow</code> returns all instances of the model at the timepoint equal to current system time.</li>
<li><code>Model.allInstancesAt(timepoint)</code> returns all instances of the model at the specified timepoint, measured in the integer amount of milliseconds elapsed since the epoch.</li>
<li><code>Model.getRepository(object)</code> will return a node representing the repository (VCS) that the object belongs to at its current timepoint. From the returned node, you may retrieve the <code>.revision</code> (SVN revision, folder timestamp or Git SHA-1), and the <code>.message</code> associated with the corresponding revision.</li>
</ul>
<h2 id="some-examples">Some examples<a class="headerlink" href="#some-examples" title="Permanent link">&para;</a></h2>
<p>A simple query to find the number of instances of X in the latest version of the model would be:</p>
<div class="codehilite"><pre><span></span><code>return X.latest.all.size;
</code></pre></div>

<p>If we want to find the second-to-last time that instances of X were created, we could write something like:</p>
<div class="codehilite"><pre><span></span><code>return X.latest.prev.time;
</code></pre></div>

<p>If we want to find an X that at some point had <code>y</code> greater than 0 and still survives to the latest revision, we could write something like:</p>
<div class="codehilite"><pre><span></span><code>return X.latest.all.select(x|x.versions.exists(vx|vx.y &gt; 0));
</code></pre></div>

<p>More advanced queries can be found in the <a href="https://gitlab.com/a.garcia-dominguez/hawk-mrt2018/tree/master/code/uk.ac.aston.mrt2018.queries">Git repository for the MRT 2018 experiment tool</a>.</p>
<h2 id="timeline-queries">Timeline queries<a class="headerlink" href="#timeline-queries" title="Permanent link">&para;</a></h2>
<p>If you want to obtain the results of a certain query for all versions of a model, you can use the TimelineEOLQueryEngine instead. This operates by repeating the same query while changing the global timepoint of the graph, so you can write your query as a normal one and see how it evolves over time. For instance, if using <code>return Model.allInstances.size;</code>, you would see how the number of instances evolved over the various versions of the graph.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>This will only process versions where type nodes changed (i.e. objects were created or deleted).</p>
</div>
<h2 id="current-limitations">Current limitations<a class="headerlink" href="#current-limitations" title="Permanent link">&para;</a></h2>
<ul>
<li>Subtree contexts, file-first/derived allOf and traversal scoping are not yet implemented for this query engine. File/repository patterns <em>do</em> work.</li>
<li>Derived features will only work if added before any VCSes are added, and the impact of adding multiple VCS with their own histories has not been tested yet. Please make sure to report any issues!</li>
</ul>





                
              </article>
            </div>
          
          
        </div>
        
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../meta-queries/" title="Meta-level queries" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Meta-level queries
              </span>
            </div>
          </a>
        
        
          <a href="../oomph/" title="Oomph and Hawk" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Oomph and Hawk
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            Copyright © Eclipse Foundation, Inc. All Rights Reserved.
          </div>
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">Material for MkDocs</a>
      </div>
      <div class="md-footer-copyright hawk-eclipse-links">
          <ul>
              <li><a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a></li>
              <li><a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a></li>
              <li><a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a></li>
          </ul>
      </div>
      <div class="md-social">
  
</div>
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    <script id="__config" type="application/json">{"base": "../..", "features": [], "search": "../../assets/javascripts/workers/search.5bf1dace.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version.title": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.078830c0.min.js"></script>
      
    
  </body>
</html>